#include <ZXMod.h>

DESC="This simple, non iterative module is just an example of how to generate "
     "a CMYK rosette screen. Threshold controls density of all channels, while Cx controls "
     "phase (to shift from open to closed Rosettes)";

DOUBLE F(DOUBLE x, DOUBLE y, DOUBLE v, DOUBLE p)
{
 DOUBLE t;

 t=(cos((x+p)*PI2)+cos((y+p)*PI2)+2)*0.25;
 if(v>t) return(1); else return(0);
}


#define C_ANGLE (15*PI/180)
#define M_ANGLE (75*PI/180)
#define Y_ANGLE (0*PI/180)
#define K_ANGLE (45*PI/180)


ULONG FUNC(x,y,_a,_b,t,it)
{
 int c;
 DOUBLE C,M,Y,K,R,G,B;


 C=F(cos(C_ANGLE)*x-sin(C_ANGLE)*y,cos(C_ANGLE)*y+sin(C_ANGLE)*x,t,_a);
 M=F(cos(M_ANGLE)*x-sin(M_ANGLE)*y,cos(M_ANGLE)*y+sin(M_ANGLE)*x,t,_a);
 Y=F(cos(Y_ANGLE)*x-sin(Y_ANGLE)*y,cos(Y_ANGLE)*y+sin(Y_ANGLE)*x,t,_a);
 K=F(cos(K_ANGLE)*x-sin(K_ANGLE)*y,cos(K_ANGLE)*y+sin(K_ANGLE)*x,t,_a);

 R= 1-K-C;
 G= 1-K-M;
 B= 1-K-Y;
 if(R<0) R=0; if(G<0) G=0; if(B<0) B=0;

 RGBRETURN((UBYTE)(R*255),(UBYTE)(G*255),(UBYTE)(B*255));
}
