#include <ZXMod.h>

 


#define X1  0
#define Y1  1
#define K1  2

#define X2  1
#define Y2  0
#define K2  2

#define X3  0
#define Y3 -1
#define K3  2

#define X4 -1
#define Y4  0
#define K4  2

#define M_RANGE 1.0  // ACTUAL RANGE WILL BE AS TWICE i.e - to + this range
#define M_STEPS 80

#define M_ADDER ((M_RANGE+M_RANGE)/M_STEPS)

#define BREAKON 100000.0




ULONG FUNC(x0,y0,a,b,t,it)
{
 register DOUBLE r,m,x,y;
 register DOUBLE d1,d2,d3,d4;
 DOUBLE l1,l2,l3,l4,s1,s2,s3,s4;
 register ULONG c,cc;

 s1=s2=s3=s4=0;

 for(cc=0,m=-M_RANGE; cc<M_STEPS; cc++, m+=M_ADDER)
 {
  x=x0;
  y=y0;
  l1=l2=l3=l4=1.0;
  d1=1.0; // just to be 100% sure

  for(c=0; c<it; c++)
  {
   r=d1;
   
   d1=((x-X1)*(x-X1)+(y-Y1)*(y-Y1));
   d2=((x-X2)*(x-X2)+(y-Y2)*(y-Y2));
   d3=((x-X3)*(x-X3)+(y-Y3)*(y-Y3));
   d4=((x-X4)*(x-X4)+(y-Y4)*(y-Y4));  

   if(d1>BREAKON) break;

   l1*=(d1+1); l2*=(d2+1); l3*=(d3+1); l4*=(d4+1);


   if((d1+m<d2)&&(d1+m<d3)&&(d1+m<d4))
   {
    x=K1*(x-X1)+X1;
    y=K1*(y-Y1)+Y1;
   }
   else if((d2+m<d1)&&(d2+m<d3)&&(d2+m<d4))
   {
    x=K2*(x-X2)+X2;
    y=K2*(y-Y2)+Y2;
    CZ;
   }
   else if((d3+m<d1)&&(d3+m<d2)&&(d3+m<d4))
   {
    x=K3*(x-X3)+X3;
    y=K3*(y-Y3)+Y3;
   }
   else
   {
    x=K4*(x-X4)+X4;
    y=K4*(y-Y4)+Y4;
   }

  } // iters loop

  l1=log(l1); l2=log(l2); l3=log(l3); l4=log(l4);

  if(c<it) // c loop broken by large value, simulate escape sequence quickly
  {
   // Borrow x and y as temp variables
   x=it-c;
   y=log(d1/r)*(x-1.0)*0.5;
   l1+= ( x*( log(d1) + y ) );
   l2+= ( x*( log(d2) + y ) );
   l3+= ( x*( log(d3) + y ) );
   l4+= ( x*( log(d4) + y ) );
  }

  l1*=l1; s1+=(cos(log(l1)*t)+1);
  l2*=l2; s2+=(cos(log(l2)*t)+1);
  l3*=l3; s3+=(cos(log(l3)*t)+1);
  l4*=l4; s4+=(cos(log(l4)*t)+1);


 } // m loop

 // stabilize gradients to M_STEPS at least. Borrow t

 t=1.0/M_STEPS;
 s1*=t; s2*=t; s3*=t; s4*=t;

 RGBRETURN((UBYTE)(s1*63.75  +s2*63.75),
           (UBYTE)(s2*31.875 +s3*31.875 +s4*63.75),
           (UBYTE)(s1*31.775 +s3*63.75  +s4*31.875));

}
